unit f_thread;

interface

uses
  Classes,sysutils;

type
  imag_process_thr = class(TThread)
    procedure UpdateBitmap;
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;

implementation

uses filters_u,filter_f;

procedure imag_process_thr.UpdateBitmap;
var i,j,k:integer;
begin
   for i:=0 to 239 do for j:=0 to 319 do for k:=0 to 2 do
      form1.directbitmap1.bmp_data^[i*1920+j*3+k+960]:=intermed[ufcopy,i*320+j,k];
   form1.directbitmap1.refresh;
   form1.memo1.Lines.clear;
   form1.memo1.Lines.add(filter_reco);
end;


procedure imag_process_thr.Execute;
var i,j:integer;
    s:string;
begin
   for i:=prcopy to ufcopy do begin
      j:=filtercopy[i,0];
      if j<0 then j:=1;
      if j>nr_filters then j:=1;
      s:=filternames[j];
      if (filtercopy[i,5]<>0) or (filtercopy[i,10]<>0) then s:=s+'(';
      if (filtercopy[i,5]<>0) then s:=s+inttostr(filtercopy[i,3]);
      if (filtercopy[i,10]<>0) then s:=s+','+inttostr(filtercopy[i,8]);
      if (filtercopy[i,5]<>0) or (filtercopy[i,10]<>0) then s:=s+')';
      filter_job:=s;
      filterpointer[j](intermed[i-1],intermed[i],filtercopy[i,3],filtercopy[i,8]);
   end;
   Synchronize(UpdateBitmap);
   b_updating:=false;
end;

end.
