unit filters_u;
{$i-}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DirectBitmap, ExtCtrls, StdCtrls, ComCtrls, FileCtrl, Gauges, Filter_f,
  Menus,f_thread;

type
  TForm1 = class(TForm)
    DirectBitmap1: TDirectBitmap;
    Timer1: TTimer;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Gauge1: TGauge;
    Label1: TLabel;
    Bevel1: TBevel;
    Label2: TLabel;
    Bevel2: TBevel;
    Label3: TLabel;
    PopupMenu1: TPopupMenu;
    Save1: TMenuItem;
    N1: TMenuItem;
    Memo1: TMemo;
    FileListBox1: TListBox;
    procedure FormActivate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListBox2StartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure Label2Click(Sender: TObject);
    procedure ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ListBox1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ListBox1StartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure Label3DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Label3DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TrackBar2Change(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  t11i=array[0..10] of integer;
  t3211i=array[1..32] of t11i;
  tpreset=record
          name:string[20];
          uf:integer;
          filter:t3211i;
          end;

var
  Form1: TForm1;
  bmph:bitmapinfoheader;
  bmfh:bitmapfileheader;
  mustexit:boolean;
  f:file;

  bmpdati:tdata;

  sumsq:array[0..2] of extended;

  b_mustrefresh:boolean;
  b_updating:boolean;

  drag_filter:t11i;

  intermed:array[0..32] of tdata;
  filter,filtercopy:t3211i;
  usedfilters,ufcopy:integer;
  lb1selection:integer;
  dragsource:integer;
  prcopy,process_start:integer;
  wthr:tthread;

  presets:array[1..100] of tpreset;
  npresets:integer;

implementation

{$R *.DFM}

procedure readfilelist; forward;

procedure TForm1.FormActivate(Sender: TObject);
var i:integer;
    f:file;
    len:integer;
    mi:tmenuitem;
begin
   readfilelist;
   system.assign(f,'presets.dat');
   system.reset(f,1);
   len:=0;
   blockread(f,presets,100*sizeof(tpreset),len);
   if ioresult<>0 then len:=0;
   system.close(f);
   npresets:=len div sizeof(tpreset);
   for i:=1 to npresets do begin
      mi:=tmenuitem.create(popupmenu1);
      mi.Caption:=presets[i].name;
      mi.tag:=i;
      mi.OnClick:=n1click;
      PopupMenu1.Items.Add(mi);
   end;
   process_start:=1;
   directbitmap1.Initialize(24);
   for i:=1 to nr_filters do ListBox2.Items.Add(filternames[i]);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i,j,k:integer;
begin
   Gauge1.progress:=filter_progress;
   Label1.Caption:=filter_job;
   if mustexit then close;
   if b_mustrefresh then begin
      if b_updating then exit;
      b_updating:=true;
      b_mustrefresh:=false;
      filtercopy:=filter;
      prcopy:=process_start;
      process_start:=33;
      ufcopy:=usedfilters;
      intermed[0]:=bmpdati;
      imag_process_thr.create(false);
   end;
end;

procedure readfilelist;
var r:tsearchrec;
    foundok:integer;
begin
   form1.filelistbox1.Clear;
   foundok:=findfirst('*.bmp',7,r);
   while true do begin
      if foundok<>0 then break;
      form1.FileListBox1.Items.Add(r.Name);
      foundok:=findnext(r);
   end;
   FindClose(r);
end;

procedure TForm1.FileListBox1Change(Sender: TObject);
var f:file;
    i,j,k:integer;
begin
   process_start:=1;
   system.assign(f,filelistbox1.Items[filelistbox1.itemindex]);
   reset(f,1);
   if ioresult=0 then begin
      blockread(f,bmfh,sizeof(bmfh));
      seek(f,bmfh.bfOffBits);
      blockread(f,bmpdati,230400);
      for i:=0 to 239 do for j:=0 to 319 do for k:=0 to 2 do
         directbitmap1.bmp_data^[i*1920+j*3+k]:=bmpdati[i*320+j,k];
      system.close(f);
      b_mustrefresh:=true;
   end;
end;



procedure TForm1.ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
//   accept:=source<>listbox1;
   accept:=true;
end;

procedure refreshfilters;
var i,z:integer;
    s:string;
begin
   form1.listbox1.items.beginupdate;
   form1.listbox1.items.clear;
   for i:=1 to usedfilters do begin
      z:=filter[i,0];
      s:=filternames[z];
      if (filter[i,5]<>0) or (filter[i,10]<>0) then s:=s+'(';
      if (filter[i,5]<>0) then s:=s+inttostr(filter[i,3]);
      if (filter[i,10]<>0) then s:=s+','+inttostr(filter[i,8]);
      if (filter[i,5]<>0) or (filter[i,10]<>0) then s:=s+')';
      form1.listbox1.items.add(s);
   end;
   form1.listbox1.items.endupdate;
   b_mustrefresh:=true;
end;

procedure TForm1.ListBox2StartDrag(Sender: TObject; var DragObject: TDragObject);
var sel,i:integer;
begin
   dragsource:=-1;
   sel:=listbox2.Itemindex+1;
   drag_filter[0]:=sel;
   for i:=1 to 10 do drag_filter[i]:=filterparam[sel,i];
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
   popupmenu1.Popup(form1.Left+288,form1.top+292);
end;

procedure TForm1.ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
var i,p,z:integer;
begin
   if drag_filter[0]=0 then exit;
   form1.TrackBar1.Enabled:=false;
   form1.TrackBar2.Enabled:=false;
   if dragsource>0 then begin
      if process_start>dragsource then process_start:=dragsource;
      for i:=dragsource to usedfilters-1 do filter[i]:=filter[i+1];
      dec(usedfilters);
   end;
   if usedfilters=32 then exit;
   inc(usedfilters);
   z:=y div listbox1.ItemHeight+1;
   if z<1 then z:=1;
   if z>usedfilters then z:=usedfilters;
   for i:=usedfilters downto z+1 do filter[i]:=filter[i-1];
   p:=z;
   if process_start>p then process_start:=p;
   filter[p]:=drag_filter;
   refreshfilters;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var sel,a,b:integer;
begin
   sel:=listbox1.ItemIndex+1;
   lb1selection:=sel;
   a:=filter[sel,3];
   b:=filter[sel,8];
   trackbar1.Min      :=0;
   trackbar1.frequency:=10000;
   trackbar1.Max      :=10000;
   trackbar1.Position :=a;
   trackbar1.Max      :=filter[sel,5];
   trackbar1.Min      :=filter[sel,1];
   trackbar1.SelStart :=filter[sel,2];
   trackbar1.SelEnd   :=filter[sel,4];
   trackbar1.frequency:=(filter[sel,5]-filter[sel,1]) div 11+1;
   trackbar2.Min      :=0;
   trackbar2.frequency:=10000;
   trackbar2.Max      :=10000;
   trackbar2.Position :=b;
   trackbar2.Max      :=filter[sel,10];
   trackbar2.Min      :=filter[sel,6];
   trackbar2.SelStart :=filter[sel,7];
   trackbar2.Selend   :=filter[sel,9];
   trackbar2.frequency:=(filter[sel,10]-filter[sel,6]) div 11+1;
   trackbar1.enabled  :=filter[sel,5]<>0;
   trackbar2.enabled  :=filter[sel,10]<>0;
   listbox1.ItemIndex:=sel-1;
   listbox1.setFocus;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var sel:integer;
begin
   sel:=lb1selection;
   if sel<1 then exit;
   if sel>32 then exit;
   if filter[sel,3]<>trackbar1.Position then begin
      if process_start>sel then process_start:=sel;
   end;
   filter[sel,3]:=trackbar1.Position;
   refreshfilters;
end;

procedure TForm1.ListBox1StartDrag(Sender: TObject; var DragObject: TDragObject);
var sel:integer;
begin
   dragsource:=-1;
   drag_filter[0]:=0;
   if listbox1.Items.Count<1 then exit;
   sel:=listbox1.ItemIndex+1;
   drag_filter:=filter[sel];
   if sel>0 then dragsource:=sel;
end;

procedure TForm1.Label3DragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
   accept:=dragsource>0;
end;

procedure TForm1.Label3DragDrop(Sender, Source: TObject; X, Y: Integer);
var i:integer;
begin
   if dragsource>0 then begin
      form1.TrackBar1.Enabled:=false;
      form1.TrackBar2.Enabled:=false;
      if process_start>dragsource then process_start:=dragsource;
      for i:=dragsource to usedfilters-1 do filter[i]:=filter[i+1];
      dec(usedfilters);
      refreshfilters;
   end;
end;

procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var i,sel:integer;
begin
   if key<>46 then exit;
   form1.TrackBar1.Enabled:=false;
   form1.TrackBar2.Enabled:=false;
   if listbox1.Items.Count<1 then exit;
   sel:=listbox1.ItemIndex+1;
   if sel<1 then exit;
   if process_start>dragsource then process_start:=sel;
   for i:=sel to usedfilters-1 do filter[i]:=filter[i+1];
   dec(usedfilters);
   refreshfilters;
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
var sel:integer;
begin
   sel:=lb1selection;
   if sel<1 then exit;
   if sel>32 then exit;
   if filter[sel,8]<>trackbar2.Position then begin
      if process_start>sel then process_start:=sel;
   end;
   filter[sel,8]:=trackbar2.Position;
   refreshfilters;
end;

procedure TForm1.Save1Click(Sender: TObject);
var mi:tmenuitem;
begin
   if npresets>=100 then exit;
   inc(npresets);
   presets[npresets].name:='Preset '+inttostr(npresets);
   presets[npresets].uf:=usedfilters;
   presets[npresets].filter:=filter;
   mi:=tmenuitem.create(popupmenu1);
   mi.Caption:=presets[npresets].name;
   mi.tag:=npresets;
   mi.OnClick:=n1click;
   PopupMenu1.Items.Add(mi);
end;

procedure TForm1.N1Click(Sender: TObject);
var p:integer;
begin
   form1.TrackBar1.Enabled:=false;
   form1.TrackBar2.Enabled:=false;
   process_start:=1;
   with sender as tmenuitem do begin
      p:=tag;
   end;
   filter:=presets[p].filter;
   usedfilters:=presets[p].uf;
   refreshfilters;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var f:file;
begin
   system.assign(f,'presets.dat');
   rewrite(f,1);
   blockwrite(f,presets,npresets*sizeof(tpreset));
   ioresult;
   system.close(f);
end;

end.

